/*
 *    X2  IRC Operator and Channel services
 *    by Rubin (rubin@afternet.org)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#include "config.h"
#include "sock.h"

ServNameSegment InitServNameSeg(ServNameSegment NewServNames)
{

  int i;

  NewServNames = (ServNameSegment) malloc(sizeof(struct ServNameSegStruct));

  if (!NewServNames)
    return (NULL);
/*  NewServNames->Next = NULL;*/
  for (i = 0; i < SERVNAMESEGSIZE; i++)
    NewServNames->Table[i] = NULL;
  return (NewServNames);
}
ServSegment InitServSeg(ServSegment NewServers)
{

  int i;
  NewServers = (ServSegment) malloc(sizeof(struct ServSegStruct));

  if (!NewServers)
    return (NULL);
/*  NewServers->Next = NULL;*/
  for (i = 0; i < SERVERSEGSIZE; i++)
    NewServers->Table[i] = NULL;
  return (NewServers);
}


UserSegment InitUserSeg(UserSegment NewUsers)
{

  int i;

  NewUsers = (UserSegment) malloc(sizeof(struct UserSegStruct));

  if (!NewUsers)
    return (NULL);
/*  NewUsers->Next = NULL;*/
  for (i = 0; i < USERSEGSIZE; i++)
    NewUsers->Table[i] = NULL;
  return (NewUsers);
}

ChanSegment InitChanSeg(ChanSegment NewChannels)
{

  int i;

  NETBURSTING = TRUE;
  NewChannels = (ChanSegment) malloc(sizeof(struct ChanSegStruct));

  if (!NewChannels)
    return (NULL);
/*  NewChannels->Next = NULL;*/
  for (i = 0; i < CHANSEGSIZE; i++)
    NewChannels->Table[i] = NULL;
  return (NewChannels);
}

int InitGlobals()
{

  ChannelCount = 0;
  ServerCount = 0;
  RoutCount = 0;
  UserCount = 0;
  OperCount = 0;
  PeonCount = 0;
  OpCount = 0;
  ManagerCount = 0;
  CoOwnerCount = 0;
  OwnerCount = 0;
  MaxSock = 0;
  RoutsOk = false;
  LastNickAdded[0] = '\0';
  Glines = NULL;
  SuperGlines = NULL;
  GatePtrs = NULL;

  /* routing table */
  Route = malloc(sizeof(struct RouteStruct));

  Route->count = 0;
  Route->maxdepth = 0;
  Route->servers = NULL;
  Route->centered = FALSE;

  strcpy(DBTARGET, "");
  DEBUG = 20;			/* INFO and higher */
  if (!(Servers = InitServSeg(Servers)))
    return (0);
  if (!(UsersN = InitUserSeg(UsersN)))
    return (0);
  if (!(UsersA = InitUserSeg(UsersA)))
    return (0);
  if (!(UsersU = InitUserSeg(UsersU)))
    return (0);
  if (!(Channels = InitChanSeg(Channels)))
    return (0);
  if (!(Routs = InitServSeg(Routs)))
    return (0);

  srand(time(NULL));
  return (1);
}


